/****************************************************************************/
/* Ώۃ}CR R8C/M12A                                                    */
/* ̧ٓe     OtBbNt䃉Cu                              */
/* o[W   Ver.1.00                                                    */
/* Date         2012.04.27                                                  */
/* Copyright    lTX}CRJ[[                            */
/****************************************************************************/

/*======================================*/
/* CN[h                         */
/*======================================*/
#include "sfr_r8m12a.h"                 /* R8C/M12A SFR̒`t@C   */
#include "glcd_lib.h"                   /* ̨t䃉Cu    */
#include "font_8x8.h"                   /* 8~8dot tHg             */

/*======================================*/
/* V{`                         */
/*======================================*/
#define glcd_left()  { GLCD_CS2 = 0;\
                        GLCD_CS1 = 1; } /* ̨t䍶I      */
#define glcd_right() { GLCD_CS1 = 0;\
                        GLCD_CS2 = 1; } /* ̨tEI      */

#define GLCD_WAIT   10                  /* ̨t@EFCg        */

/*======================================*/
/* O[oϐ̐錾                 */
/*======================================*/
static int glcd_x;                      /* ̨t X\ʒu    */
static int glcd_y;                      /* ̨t Yʒuʒu    */
static int glcd_k;                      /* 0:J^Ji@1:Ђ炪Ȃŕ\ */

static unsigned char glcd_cmd1;         /* GLCDR}h1                */
static unsigned char glcd_cmd2;         /* GLCDR}h2                */

/************************************************************************/
/* OtBbNtɃR}h𑗂                                     */
/* @ R}h                                                  */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void glcd_cmd( unsigned char c )
{
    int i;

    GLCD_RS = 0;                        /* Mf[^̓R}h         */
    GLCD_DATA = c;
    GLCD_E = 1;
    GLCD_E = 0;

    for( i=0; i<GLCD_WAIT; i++ );       /* ̨t I҂     */
}

/************************************************************************/
/* OtBbNtɃf[^𑗂                                       */
/* @ f[^                                                    */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void glcd_data( unsigned char c )
{
    int i;

    GLCD_RS = 1;                        /* Mf[^̓f[^           */
    GLCD_DATA = c;
    GLCD_E = 1;
    GLCD_E = 0;

    for( i=0; i<GLCD_WAIT; i++ );       /* ̨t I҂     */
}

/************************************************************************/
/* OtBbNt̕\ʒuw                                 */
/* @ x:0`127 y:0`7(\hbǵAy*8̈ʒu)                      */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_position( unsigned char x, unsigned char y )
{
    if( x < 64 ) {
        glcd_left();                    /* 64Ȃ獶               */
    } else {
        glcd_right();                   /* 64ȏȂE               */
    }

    glcd_x = x;
    glcd_y = y;

    glcd_cmd( 0x40 | (x & 0x3f) );      /*                            */
    glcd_cmd( 0xb8 | (y & 0x07) );      /* c                           */
}

/************************************************************************/
/* OtBbNtNA                                             */
/* @ Ȃ                                                          */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_clear( void )
{
    unsigned char x, y;

    for( y=0; y<8; y++ ) {
        for( x=0; x<128; x++ ) {
            glcd_position( x, y );
            glcd_data( 0x00 );          /* 0x00ŉʃNA             */
        }
    }
    glcd_x = 0;
    glcd_y = 0;
}

/************************************************************************/
/* OtBbNt                                             */
/* @ long \鐔l, int (1`10)                            */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_init( void )
{
    GLCD_RST = 1;                       /* [q               */
    GLCD_CS2 = 0;
    GLCD_CS1 = 0;
    GLCD_E   = 0;
    GLCD_RS  = 0;

    GLCD_RST = 0;                       /* Zbg                     */
    GLCD_RST = 1;

    glcd_left();                        /* I                     */
    glcd_cmd( 0x3f );                   /* Display ON                   */

    glcd_right();                       /* EI                     */
    glcd_cmd( 0x3f );                   /* Display ON                   */

    glcd_clear();                       /* ʃNA                   */
}

/************************************************************************/
/* OtBbNt 1oCgM̃J^JiAЂ炪ȂI             */
/* @ 0:ϊȂ(J^Ji\) 1:J^JiЂ炪Ȃɕϊĕ\   */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_kana( int flag )
{
    if( flag ) {
        glcd_k = 1;                     /* Ђ炪ȕ\                 */
    } else {
        glcd_k = 0;                     /* J^Ji\                 */
    }
}

/************************************************************************/
/* OtBbNt 1C\(1~8dot)                                */
/* @ \f[^(1bytes=1~8dot)                                  */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_put_data( unsigned char data )
{
    // 1C(1~8dot)\
    glcd_position( glcd_x, glcd_y );
    glcd_data( data );
    glcd_x++;
    if( glcd_x >= 128 ) {               /* Xʒȕ`FbN          */
        glcd_x  = 0;
        glcd_y += 1;
        if( glcd_y >= 8 ) glcd_y = 0;   /* Yʒȕ`FbN          */
    }
}

/************************************************************************/
/* OtBbNt 1\                                           */
/* @ int data \                                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_put_ch( int data )
{
    int i;

    // Ђ炪ȕ\`FbN
    if( glcd_k ) {
        if( data >= 0xa6 && data <= 0xbf ) {
            data -= 0x20;
        } else if( data >= 0xc0 && data <= 0xfd ) {
            data += 0x20;
        }
    }

    data -= 0x20;
    data <<= 3;

    // 1\
    for( i=0; i<8; i++ ) {
        glcd_position( glcd_x, glcd_y );
        glcd_data( font[data++] );
        glcd_x++;
        if( glcd_x >= 128 ) {               /* Xʒȕ`FbN      */
            glcd_x  = 0;
            glcd_y += 1;
            if( glcd_y >= 8 ) glcd_y = 0;   /* Yʒȕ`FbN      */
            break;
        }
    }
}

/************************************************************************/
/* OtBbNtɐl(10i)\                                 */
/* @ long \鐔l, int (1`8)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_put_num( long value, int keta )
{
    long temp = 0;
    int i = keta-1;

    while( (i--) != 0 ) {
        temp += value % 10;
        value /= 10;
        temp <<= 4;
    }
    temp += (value % 10 );

    do {
        glcd_put_ch( (temp & 0xf) + '0' );  /* 1\                */
        temp >>= 4;
    } while( --keta );
}

/************************************************************************/
/* OtBbNtɐl(16i)\                                 */
/* @ long \鐔l, int (1`8)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_put_hex( unsigned long value, int keta )
{
    long temp = 0;
    int i = keta-1;
    char c;

    while( (i--) != 0 ) {
        temp += (value & 0x0f);
        value >>= 4;
        temp <<= 4;
    }
    temp += (value & 0xf);

    do {
        c = temp & 0x0f;
        c += (c < 10) ? '0' : ('a'-10);
        glcd_put_ch( c );               /* 1\                    */
        temp >>= 4;
    } while( --keta );
}

/************************************************************************/
/* OtBbNt \                                          */
/* @ char *str : ̐擪|C^                              */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_put_str( const char *str )
{
    while(*str != 0) {
        glcd_put_ch( *str );             /* 1M                   */
        str++;
    }
}

/************************************************************************/
/* end of file                                                          */
/************************************************************************/

/*
o
Ver.1.00 2012.04.27 쐬
*/